-- Chat zenet
function echo(message)
	Turbine.Shell.WriteLine(message);
end
-- Kerekts
function round(what, precision)
   return math.floor(what*math.pow(10,precision)+0.5) / math.pow(10,precision)
end

-- 0-255 szmbl 0-1 kzttit csinl
function rgb(num)
	return round(num/255,2);
end

-- Bevezet karival feltlt
function fill(text, pattern, length)
	if string.len(text)<length then
		text = string.rep(pattern, length-string.len(text)) .. text;
	end
	return text;
end

-- dev zenetrs chatre, script.log-ba debugMode=true esetn dtummal, logban nvvel
function debug(message)
	if debugMode then
		local getdate = Turbine.Engine.GetDate();
		message = fill(getdate.Hour,"0",2) ..":".. fill(getdate.Minute,"0",2) ..":".. fill(getdate.Second,"0",2) .." ".. message;
		Turbine.Shell.WriteLine(message);
		Turbine.Engine.ScriptLog(debugPluginName .."|".. message);
	end
end

--
-- hasznlat: seen = {}; DumpTable( table, "  ", seen );
function DumpTable( t, indentation, seen )
	if ( t == nil ) then
		Turbine.Shell.WriteLine( indentation .. "(nil)" );
		return;
	end
	seen[t] = true;
	local s= {};
	local n = 0;
	for k in pairs(t) do
		n = n + 1;
		s[n] = k;
	end
	table.sort(s, function(a,b) return tostring(a) < tostring(b) end);
	for k,v in pairs(s) do
		Turbine.Shell.WriteLine( indentation .. tostring( v ) .. ": " .. tostring( t[v] ) );
		if type( t[v] ) == "table" and not seen[t[v]] then
			DumpTable( t[v], indentation .. "  ", seen );
		end
	end
end

--[[
-- LEFT OUT for now. Plugin doesn't use any common callbacks
-- This is the callback mechanism provided by Pengoros, slightly modified by Garan to guarantee uniqueness
function AddCallback(object, event, callback)
	if (object[event] == nil) then
		object[event] = callback;
	else
		if (type(object[event]) == "table") then
			local exists=false;
			local k,v;
			for k,v in ipairs(object[event]) do
				if v==callback then
					exists=true;
					break;
				end
			end
			if not exists then
				table.insert(object[event], callback);
			end
		else
			if object[event]~=callback then
				object[event] = {object[event], callback};
			end
		end
	end
	return callback;
end

-- safely remove a callback without clobbering any extras
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end
]] -- 

-- End of File

